diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/src/alisp.s v15.6301-amd64/pop/src/alisp.s
--- v15.63/pop/src/alisp.s	1994-01-26 05:31:21.000000000 -0500
+++ v15.6301-amd64/pop/src/alisp.s	2005-03-11 05:30:39.000000000 -0500
@@ -16,7 +16,7 @@
 
 	;;; User stack pointer
 
-	USP 	= "ebx",
+	USP 	= "rbx",
 
 );
 
@@ -27,10 +27,10 @@
 /************************* wrapping structures ************************/
 
 	.text
-	.long	Ltext_size, C_LAB(Sys$-objmod_pad_key)
+	.quad	Ltext_size, C_LAB(Sys$-objmod_pad_key)
 Ltext_start:
 	.data
-	.long	Ldata_size, C_LAB(Sys$-objmod_pad_key)
+	.quad	Ldata_size, C_LAB(Sys$-objmod_pad_key)
 Ldata_start:
 
 /**********************************************************************/
@@ -65,25 +65,26 @@
 	;;; in EAX. The two arguments are in popint words; subtracting
 	;;; 6 from the total converts to sysint bytes.
 
-	movl	(%USP), %eax
-	addl	4(%USP), %eax
-	subl	$6, %eax
-	addl	$8, %USP
+	movq	(%USP), %rax
+	addq	8(%USP), %rax
+	subq	$6, %rax
+        shlq    $1, %rax
+	addq	$16, %USP
 
 	;;; Compute the desired stack pointer (_userhi - desired_length)
 	;;; in ECX
 
-	movl	I_LAB(_userhi), %ecx
-	subl	%eax, %ecx
+	movq	I_LAB(_userhi), %rcx
+	subq	%rax, %rcx
 
 	;;; Compare desired and actual stack pointers: if different,
 	;;; jump to fix
 
-	cmpl	%ecx, %USP
+	cmpq	%rcx, %USP
 	jne	C_LAB(_setstklen_diff)
 	ret
 
-	.align	4
+	.align  16
 
 DEF_C_LAB (_setstklen_diff)
 
@@ -95,16 +96,16 @@
 L1.1:	;;; Actual stack is too short: push nils until the desired size
 	;;; is reached
 
-	subl	$4, %USP
-	movl	$C_LAB(nil), (%USP)
-	cmpl	%ecx, %USP
+	subq	$8, %USP
+	movq	$C_LAB(nil), (%USP)
+	cmpq	%rcx, %USP
 	jne	L1.1
 	ret
 
 L2.1:	;;; Actual stack is too long: erase the extra results simply by
 	;;; setting USP to the desired value
 
-	movl	%ecx, %USP
+	movq	%rcx, %USP
 	ret
 
 	.align 	4
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/src/amain.s v15.6301-amd64/pop/src/amain.s
--- v15.63/pop/src/amain.s	2008-12-02 11:23:55.000000000 -0500
+++ v15.6301-amd64/pop/src/amain.s	2009-12-25 02:56:37.000000000 -0500
@@ -1,4 +1,4 @@
-/* --- Copyright University of Sussex, University of Birmingham 2008. All rights reserved. ----------
+/* --- Copyright University of Sussex 1996. All rights reserved. ----------
  * File:        S.pcunix/src/amain.s
  * Purpose:     Poplog entry point for Intel 80x86 (Unix assembler)
  * Author:      Robert Duncan, Oct 31 1988 (see revisions)
@@ -10,7 +10,7 @@
 #_INCLUDE 'declare.ph'
 
 lconstant macro (
-	USP		= "ebx",
+	USP		= "rbx",
 	SAVED_USP	= [I_LAB(Sys$-Extern$- _saved_usp)],
 );
 
@@ -29,10 +29,10 @@
 /************************* wrapping structures ************************/
 
 	.text
-	.long	Ltext_size, C_LAB(Sys$-objmod_pad_key)
+	.quad	Ltext_size, C_LAB(Sys$-objmod_pad_key)
 Ltext_start:
 	.data
-	.long	Ldata_size, C_LAB(Sys$-objmod_pad_key)
+	.quad	Ldata_size, C_LAB(Sys$-objmod_pad_key)
 Ldata_start:
 
 /**********************************************************************/
@@ -53,24 +53,17 @@
 
 	;;; Clear __pop_in_user_extern
 
-	movl	$0, EXTERN_NAME(__pop_in_user_extern)
+	movq	$0, EXTERN_NAME(__pop_in_user_extern)
 
 	;;; Save pointer to argument vector (argv)
 
-	movl	8(%esp), %eax
-	movl	%eax, I_LAB(Sys$- _init_args)
-
+	movq    %rsi,  I_LAB(Sys$- _init_args)
 
 #_IF DEF LINUX
 
-        ;;; set personality (AS, from Waldek Hebisch. 2 Dec 2008)
-        movl 12(%esp), %edx
-        movl  4(%esp), %ecx
-        push %edx
-        push %eax
-        push %ecx
+        ;;; set personality
+
         call linux_setper
-        addl $12, %esp
 
 #_ENDIF
 
@@ -80,18 +73,22 @@
 
 	;;; Set up a temporary user stack pointer
 
-	movl	SAVED_USP, %USP
-
-	;;; Start the system
+	movq	SAVED_USP, %USP
 
+	;;; clear Pop registers
+        movq    $3, %r13
+        movq    $3, %r14
+        movq    $3, %r15
+        
+        ;;; Start the system
 	call	XC_LAB(setpop)
 
 	;;; Exit with 0
 
-	pushl	$0
+	movl    $0, %edi
 	call	EXTERN_NAME(_exit)
 
-	.align	4
+	.align  16
 
 
 /***************** end labels for wrapping structures *****************/
@@ -106,9 +103,6 @@
 /**********************************************************************/
 
 /* --- Revision History ---------------------------------------------------
---- Aaron Sloman, 2 Dec 2008
-	Installed call of linux_setper, using code provided by
-	Waldek Hebisch, to make running with 'setarch' unnecessary.
 --- Robert Duncan, Aug  9 1996
 	Removed special cases for S*CO
 --- Poplog System, Jan 18 1995
Only in v15.63/pop/src: amain.s.1996
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/src/amisc.s v15.6301-amd64/pop/src/amisc.s
--- v15.63/pop/src/amisc.s	1997-02-10 12:17:29.000000000 -0500
+++ v15.6301-amd64/pop/src/amisc.s	2009-12-27 15:49:45.000000000 -0500
@@ -17,16 +17,17 @@
 
 constant
 	procedure (Call_overflow, User_overflow, Callstack_reset,
-	Conspair, Plog$-Area_overflow, Async_raise_signal)
+	Conspair, Plog$-Area_overflow, Async_raise_signal,
+        dummy_procedure_callback_helper)
 	;
 
 endsection;
 
 lconstant macro (
 
-	USP			= "ebx",
-	PB			= "ebp",
-	CHAIN_REG		= "edx",
+	USP			= "rbx",
+	PB			= "rbp",
+	CHAIN_REG		= "rdx",
 
 	_KEY			= @@KEY,
 	_K_APPLY		= @@K_APPLY,
@@ -42,6 +43,14 @@
 
 );
 
+lconstant macro MOVFL   = if DEF FRAME_LEN_16BIT then "movzwl"
+                          elseif DEF FRAME_LEN_32BIT then "movl"
+                          else "movzbl"
+                          endif;
+
+lconstant macro RAX = if DEF FRAME_LEN_32BIT then "eax" else "rax" endif;
+lconstant macro RCX = if DEF FRAME_LEN_32BIT then "ecx" else "rcx" endif;
+
 >_#
 
 	.file	"amisc.s"
@@ -49,10 +58,10 @@
 /************************* wrapping structures ************************/
 
 	.text
-	.long	Ltext_size, C_LAB(Sys$-objmod_pad_key)
+	.quad	Ltext_size, C_LAB(Sys$-objmod_pad_key)
 Ltext_start:
 	.data
-	.long	Ldata_size, C_LAB(Sys$-objmod_pad_key)
+	.quad	Ldata_size, C_LAB(Sys$-objmod_pad_key)
 Ldata_start:
 
 /**********************************************************************/
@@ -78,50 +87,50 @@
 
 	;;; Test object for simple or compound
 
-	testl	$1, %eax
+	testq	$1, %rax
 	jnz	L1.1
 
 	;;; Object is compound: compare key with procedure key
 
-	cmpl	$C_LAB(procedure_key), _KEY(%eax)
+	cmpq	$C_LAB(procedure_key), _KEY(%rax)
 	jne	L3.1
 
 	;;; Applying a procedure: jump to its execute address
 
-	jmp	*_PD_EXECUTE(%eax)
+	jmp	*_PD_EXECUTE(%rax)
 
 L1.1:	;;; Applying a (simple) number:
 	;;; push the number and run the appropriate key apply procedure
 	;;; (integer or decimal)
 
-	subl	$4, %USP
-	movl	%eax, (%USP)
-	testl	$2, %eax
+	subq	$8, %USP
+	movq	%rax, (%USP)
+	testq	$2, %rax
 	jz	L2.1
 
 	;;; Applying an integer
 
-	movl	C_LAB(integer_key) + _K_APPLY, %eax
-	movl	_RF_CONT(%eax), %eax
-	jmp	*_PD_EXECUTE(%eax)
+	movq	C_LAB(integer_key) + _K_APPLY, %rax
+	movq	_RF_CONT(%rax), %rax
+	jmp	*_PD_EXECUTE(%rax)
 
 L2.1:	;;; Applying a decimal
 
-	movl	C_LAB(weakref decimal_key) + _K_APPLY, %eax
-	movl	_RF_CONT(%eax), %eax
-	jmp	*_PD_EXECUTE(%eax)
+	movq	C_LAB(weakref decimal_key) + _K_APPLY, %rax
+	movq	_RF_CONT(%rax), %rax
+	jmp	*_PD_EXECUTE(%rax)
 
 L3.1:	;;; Applying a structure:
 	;;; push the object and run the key apply procedure
 
-	subl	$4, %USP
-	movl	%eax, (%USP)
-	movl	_KEY(%eax), %eax
-	movl	_K_APPLY(%eax), %eax
-	movl	_RF_CONT(%eax), %eax
-	jmp	*_PD_EXECUTE(%eax)
+	subq	$8, %USP
+	movq	%rax, (%USP)
+	movq	_KEY(%rax), %rax
+	movq	_K_APPLY(%rax), %rax
+	movq	_RF_CONT(%rax), %rax
+	jmp	*_PD_EXECUTE(%rax)
 
-	.align	4
+	.align  16
 
 
 ;;; _POPUENTER:
@@ -145,12 +154,12 @@
 
 	;;; Test object for simple or compound
 
-	testl	$1, %eax
+	testq	$1, %rax
 	jnz	L1.2
 
 	;;; Object is compound: compare key with procedure key
 
-	cmpl	$C_LAB(procedure_key), _KEY(%eax)
+	cmpq	$C_LAB(procedure_key), _KEY(%rax)
 	jne	L3.2
 
 	;;; Applying the updater of a procedure: fall through to the
@@ -162,68 +171,68 @@
 	;;; copy it to ECX for possible use as an argument to the error
 	;;; routine, then get its updater
 
-	movl	%eax, %ecx
-	movl	_PD_UPDATER(%eax), %eax
+	movq	%rax, %rcx
+	movq	_PD_UPDATER(%rax), %rax
 
 	;;; If the updater is <false> (non-existent) jump to the error case
 
-	cmpl	$C_LAB(false), %eax
+	cmpq	$C_LAB(false), %rax
 	je	no_updater
 
 	;;; Otherwise go to the updater's execute address
 
-	jmp	*_PD_EXECUTE(%eax)
+	jmp	*_PD_EXECUTE(%rax)
 
 L1.2:	;;; Applying the updater of a number:
 	;;; copy the number to ECX (to be pushed as an argument later)
 	;;; then get the appropriate key apply procedure (integer or decimal)
 	;;; in EAX. Jump to check (and apply) its updater
 
-	movl	%eax, %ecx
-	testl	$2, %eax
+	movq	%rax, %rcx
+	testq	$2, %rax
 	jz	L2.2
 
 	;;; Integer key
 
-	movl	C_LAB(integer_key) + _K_APPLY, %eax
+	movq	C_LAB(integer_key) + _K_APPLY, %rax
 	jmp	L4.1
 
 L2.2:	;;; Decimal key
 
-	movl	C_LAB(weakref decimal_key) + _K_APPLY, %eax
+	movq	C_LAB(weakref decimal_key) + _K_APPLY, %rax
 	jmp	L4.1
 
 L3.2:	;;; Applying the updater of a structure:
 	;;; copy the object to ECX (to be pushed as an argument later)
 	;;; then get its key apply procedure in EAX
 
-	movl	%eax, %ecx
-	movl	_KEY(%eax), %eax
-	movl	_K_APPLY(%eax), %eax
+	movq	%rax, %rcx
+	movq	_KEY(%rax), %rax
+	movq	_K_APPLY(%rax), %rax
 
 L4.1:	;;; Check the updater of the key apply procedure in EAX
 
-	movl	_RF_CONT(%eax), %eax
-	movl	_PD_UPDATER(%eax), %eax
-	cmpl	$C_LAB(false), %eax
+	movq	_RF_CONT(%rax), %rax
+	movq	_PD_UPDATER(%rax), %rax
+	cmpq	$C_LAB(false), %rax
 	je	no_updater
 
 	;;; Updater OK -- push the original object (now in ECX) as an
 	;;; argument to it, and jump to its execute address
 
-	subl	$4, %USP
-	movl	%ecx, (%USP)
-	jmp	*_PD_EXECUTE(%eax)
+	subq	$8, %USP
+	movq	%rcx, (%USP)
+	jmp	*_PD_EXECUTE(%rax)
 
 no_updater:
 
 	;;; Object in ECX has no updater -- raise an error
 
-	subl	$4, %USP
-	movl	%ecx, (%USP)
+	subq	$8, %USP
+	movq	%rcx, (%USP)
 	jmp	XC_LAB(-> Sys$-Exec_nonpd)
 
-	.align	4
+	.align  16
 
 
 ;;; === CALLSTACK MANIPULATION ========================================
@@ -235,11 +244,11 @@
 
 DEF_C_LAB (_erase_sp_1)
 
-	popl	%eax
-	movl	%eax, (%esp)
+	popq	%rax
+	movq	%rax, (%rsp)
 	jmp	XC_LAB(Sys$-Callstack_reset)
 
-	.align	4
+	.align  16
 
 
 ;;; _NEXTFRAME:
@@ -252,25 +261,25 @@
 
 	;;; Load frame pointer to EAX
 
-	movl	(%USP), %eax
+	movq	(%USP), %rax
 
 	;;; Owner address in ECX
 
-	movl	_SF_OWNER(%eax), %ecx
+	movq	_SF_OWNER(%rax), %rcx
 
 	;;; Find the length of the frame (in longwords) from the owner's
 	;;; procedure header
 
-	movzbl	_PD_FRAME_LEN(%ecx), %ecx
+	MOVFL	_PD_FRAME_LEN(%rcx), %ecx
 
 	;;; Add the frame length in bytes (ECX * 4) to the given frame
 	;;; pointer to get the next frame pointer.
 
-	leal	(%eax, %ecx, 4), %eax
-	movl	%eax, (%USP)
+	leaq	(%rax, %rcx, 8), %rax
+	movq	%rax, (%USP)
 	ret
 
-	.align	4
+	.align  16
 
 
 ;;; _UNWIND_FRAME:
@@ -298,22 +307,22 @@
 	;;; Extract the length of the previous stack frame (in longwords)
 	;;; from its owner procedure, whose address should be in PB
 
-	movzbl	_PD_FRAME_LEN(%PB), %eax
+	MOVFL	_PD_FRAME_LEN(%PB), %eax
 
 	;;; The last word in that frame will be the return address:
 	;;; copy that to CHAIN_REG, then replace it with our return
 
-	leal	4(%esp, %eax, 4), %eax
-	movl	(%eax), %CHAIN_REG
-	popl	(%eax)
+	leaq	8(%rsp, %rax, 8), %rax
+	movq	(%rax), %CHAIN_REG
+	popq	(%rax)
 
 	;;; Clear the unwanted return address from the stack and go into
 	;;; the procedure's exit code
 
-	addl	$4, %esp
+	addq	$8, %rsp
 	jmp	*_PD_EXIT(%PB)
 
-	.align	4
+	.align  16
 
 ;;; === CHAINING A POP PROCEDURE ======================================
 
@@ -337,7 +346,7 @@
 	;;; Set up a dummy return address for _UNWIND_FRAME and call it;
 	;;; this will leave the caller's return address in CHAIN_REG
 
-	pushl	$0
+	pushq	$0
 	call	C_LAB(_unwind_frame)
 
 	;;; Fall through to direct chain
@@ -346,22 +355,22 @@
 
 	;;; Reinstate the return address from CHAIN_REG
 
-	pushl	%CHAIN_REG
+	pushq	%CHAIN_REG
 
 	;;; Get the object to chain from the stack and run it
 
-	movl	(%USP), %eax
-	addl	$4, %USP
+	movq	(%USP), %rax
+	addq	$8, %USP
 	jmp	C_LAB(_popenter)
 
-	.align	4
+	.align  16
 
 DEF_C_LAB (_sysncchain_caller)
 
 	;;; Set up a dummy return address for _UNWIND_FRAME and call it;
 	;;; this will leave the caller's return address in CHAIN_REG
 
-	pushl	$0
+	pushq	$0
 	call	C_LAB(_unwind_frame)
 
 	;;; Fall through to direct chain
@@ -370,16 +379,16 @@
 
 	;;; Reinstate the return address from CHAIN_REG
 
-	pushl	%CHAIN_REG
+	pushq	%CHAIN_REG
 
 	;;; Get the procedure to chain from the stack and go to its execute
 	;;; address
 
-	movl	(%USP), %eax
-	addl	$4, %USP
-	jmp	*_PD_EXECUTE(%eax)
+	movq	(%USP), %rax
+	addq	$8, %USP
+	jmp	*_PD_EXECUTE(%rax)
 
-	.align	4
+	.align  16
 
 
 ;;; === PREDICATES ON POP OBJECTS =====================================
@@ -398,67 +407,67 @@
 
 	;;; Object is a pop pointer -- bottom bit clear
 
-	testl	$1, (%USP)
+	testq	$1, (%USP)
 	jz	return_true
-	movl	$C_LAB(false), (%USP)
+	movq	$C_LAB(false), (%USP)
 	ret
 
-	.align	4
+	.align  16
 
 DEF_C_LAB (_issimple)
 
 	;;; Object is not a pop pointer -- bottom bit set
 
-	testl	$1, (%USP)
+	testq	$1, (%USP)
 	jnz	return_true
-	movl	$C_LAB(false), (%USP)
+	movq	$C_LAB(false), (%USP)
 	ret
 
-	.align	4
+	.align  16
 
 DEF_C_LAB (_isinteger)
 
 	;;; Object is a pop integer -- second bit set
 
-	testl	$2, (%USP)
+	testq	$2, (%USP)
 	jnz	return_true
-	movl	$C_LAB(false), (%USP)
+	movq	$C_LAB(false), (%USP)
 	ret
 
-	.align	4
+	.align  16
 
 DEF_C_LAB (_neg)
 
 	;;; Object is negative
 
-	cmpl	$0, (%USP)
+	cmpq	$0, (%USP)
 	jl	return_true
-	movl	$C_LAB(false), (%USP)
+	movq	$C_LAB(false), (%USP)
 	ret
 
-	.align	4
+	.align  16
 
 DEF_C_LAB (_zero)
 
 	;;; Object is (machine) zero
 
-	cmpl	$0, (%USP)
+	cmpq	$0, (%USP)
 	je	return_true
-	movl	$C_LAB(false), (%USP)
+	movq	$C_LAB(false), (%USP)
 	ret
 
-	.align	4
+	.align  16
 
 DEF_C_LAB (_not)
 
 	;;; Object is false
 
-	cmpl	$C_LAB(false), (%USP)
+	cmpq	$C_LAB(false), (%USP)
 	je	return_true
-	movl	$C_LAB(false), (%USP)
+	movq	$C_LAB(false), (%USP)
 	ret
 
-	.align	4
+	.align  16
 
 ;;; _EQ:
 ;;; _NEQ:
@@ -477,145 +486,145 @@
 
 	;;; Identity (pop ==)
 
-	movl	(%USP), %eax
-	addl	$4, %USP
-	cmpl	%eax, (%USP)
+	movq	(%USP), %rax
+	addq	$8, %USP
+	cmpq	%rax, (%USP)
 	je	return_true
-	movl	$C_LAB(false), (%USP)
+	movq	$C_LAB(false), (%USP)
 	ret
 
-	.align	4
+	.align  16
 
 DEF_C_LAB 7 (_neq)
 
 	;;; Non-identity (pop /==)
 
-	movl	(%USP), %eax
-	addl	$4, %USP
-	cmpl	%eax, (%USP)
+	movq	(%USP), %rax
+	addq	$8, %USP
+	cmpq	%rax, (%USP)
 	jne	return_true
-	movl	$C_LAB(false), (%USP)
+	movq	$C_LAB(false), (%USP)
 	ret
 
-	.align	4
+	.align  16
 
 DEF_C_LAB 6 (_gr)
 
 	;;; Unsigned greater than
 
-	movl	(%USP), %eax
-	addl	$4, %USP
-	cmpl	%eax, (%USP)
+	movq	(%USP), %rax
+	addq	$8, %USP
+	cmpq	%rax, (%USP)
 	ja	return_true
-	movl	$C_LAB(false), (%USP)
+	movq	$C_LAB(false), (%USP)
 	ret
 
-	.align	4
+	.align  16
 
 DEF_C_LAB 6 (_greq)
 
 	;;; Unsigned greater than or equal
 
-	movl	(%USP), %eax
-	addl	$4, %USP
-	cmpl	%eax, (%USP)
+	movq	(%USP), %rax
+	addq	$8, %USP
+	cmpq	%rax, (%USP)
 	jae	return_true
-	movl	$C_LAB(false), (%USP)
+	movq	$C_LAB(false), (%USP)
 	ret
 
-	.align	4
+	.align  16
 
 DEF_C_LAB 6 (_lt)
 
 	;;; Unsigned less than
 
-	movl	(%USP), %eax
-	addl	$4, %USP
-	cmpl	%eax, (%USP)
+	movq	(%USP), %rax
+	addq	$8, %USP
+	cmpq	%rax, (%USP)
 	jb	return_true
-	movl	$C_LAB(false), (%USP)
+	movq	$C_LAB(false), (%USP)
 	ret
 
-	.align	4
+	.align  16
 
 DEF_C_LAB 6 (_lteq)
 
 	;;; Unsigned less than or equal
 
-	movl	(%USP), %eax
-	addl	$4, %USP
-	cmpl	%eax, (%USP)
+	movq	(%USP), %rax
+	addq	$8, %USP
+	cmpq	%rax, (%USP)
 	jbe	return_true
-	movl	$C_LAB(false), (%USP)
+	movq	$C_LAB(false), (%USP)
 	ret
 
-	.align	4
+	.align  16
 
 DEF_C_LAB 6 (_sgr)
 
 	;;; Signed greater than
 
-	movl	(%USP), %eax
-	addl	$4, %USP
-	cmpl	%eax, (%USP)
+	movq	(%USP), %rax
+	addq	$8, %USP
+	cmpq	%rax, (%USP)
 	jg	return_true
-	movl	$C_LAB(false), (%USP)
+	movq	$C_LAB(false), (%USP)
 	ret
 
-	.align	4
+	.align  16
 
 DEF_C_LAB 6 (_sgreq)
 
 	;;; Signed greater than or equal
 
-	movl	(%USP), %eax
-	addl	$4, %USP
-	cmpl	%eax, (%USP)
+	movq	(%USP), %rax
+	addq	$8, %USP
+	cmpq	%rax, (%USP)
 	jge	return_true
-	movl	$C_LAB(false), (%USP)
+	movq	$C_LAB(false), (%USP)
 	ret
 
-	.align	4
+	.align  16
 
 DEF_C_LAB 6 (_slt)
 
 	;;; Signed less than
 
-	movl	(%USP), %eax
-	addl	$4, %USP
-	cmpl	%eax, (%USP)
+	movq	(%USP), %rax
+	addq	$8, %USP
+	cmpq	%rax, (%USP)
 	jl	return_true
-	movl	$C_LAB(false), (%USP)
+	movq	$C_LAB(false), (%USP)
 	ret
 
-	.align	4
+	.align  16
 
 DEF_C_LAB 6 (_slteq)
 
 	;;; Signed less than or equal
 
-	movl	(%USP), %eax
-	addl	$4, %USP
-	cmpl	%eax, (%USP)
+	movq	(%USP), %rax
+	addq	$8, %USP
+	cmpq	%rax, (%USP)
 	jle	return_true
-	movl	$C_LAB(false), (%USP)
+	movq	$C_LAB(false), (%USP)
 	ret
 
-	.align	4
+	.align  16
 
 ;;; _BITST:
 ;;;	Logical AND two items and test for non-zero (pop &&/=_0)
 
 DEF_C_LAB 4 (_bitst)
 
-	movl	(%USP), %eax
-	addl	$4, %USP
-	testl	%eax, (%USP)
+	movq	(%USP), %rax
+	addq	$8, %USP
+	testq	%rax, (%USP)
 	jnz	return_true
-	movl	$C_LAB(false), (%USP)
+	movq	$C_LAB(false), (%USP)
 	ret
 
-	.align	4
+	.align  16
 
 ;;; _HASKEY:
 ;;;	tests whether the first item on stack is the key of the second item.
@@ -634,32 +643,32 @@
 
 	;;; Load key to ECX
 
-	movl	(%USP), %ecx
-	addl	$4, %USP
+	movq	(%USP), %rcx
+	addq	$8, %USP
 
 	;;; Load item to EAX and test for compound:
 	;;; return <false> if not
 
-	movl	(%USP), %eax
-	testl	$1, %eax
+	movq	(%USP), %rax
+	testq	$1, %rax
 	jnz	L1.3
 
 	;;; Compare keys
 
-	cmpl	%ecx, _KEY(%eax)
+	cmpq	%rcx, _KEY(%rax)
 	je	return_true
-L1.3:	movl	$C_LAB(false), (%USP)
+L1.3:	movq	$C_LAB(false), (%USP)
 	ret
 
-	.align	4
+	.align  16
 
 
 return_true:
 
-	movl	$C_LAB(true), (%USP)
+	movq	$C_LAB(true), (%USP)
 	ret
 
-	.align	4
+	.align  16
 
 
 ;;; === OPTIMISED DATA ROUTINES =======================================
@@ -674,33 +683,33 @@
 
 	;;; Get the free pair list
 
-	movl	I_LAB(Sys$- _free_pairs), %eax
+	movq	I_LAB(Sys$- _free_pairs), %rax
 
 	;;; If its simple, there's nothing left -- chain the storage
 	;;; allocater
 
-	testl	$1, %eax
+	testq	$1, %rax
 	jnz	XC_LAB(Sys$-Conspair)
 
 	;;; Otherwise, take the first pair from the free list
 
-	movl	_P_BACK(%eax), %ecx
-	movl	%ecx, I_LAB(Sys$- _free_pairs)
+	movq	_P_BACK(%rax), %rcx
+	movq	%rcx, I_LAB(Sys$- _free_pairs)
 
 	;;; Initialise the new pair with the values from the stack
 
-	movl	(%USP), %ecx
-	movl	%ecx, _P_BACK(%eax)
-	movl	4(%USP), %ecx
-	movl	%ecx, _P_FRONT(%eax)
+	movq	(%USP), %rcx
+	movq	%rcx, _P_BACK(%rax)
+	movq	8(%USP), %rcx
+	movq	%rcx, _P_FRONT(%rax)
 
 	;;; Return the pair
 
-	addl	$4, %USP
-	movl	%eax, (%USP)
+	addq	$8, %USP
+	movq	%rax, (%USP)
 	ret
 
-	.align	4
+	.align  16
 
 
 ;;; _DATAKEY:
@@ -713,33 +722,33 @@
 
 	;;; Load item to EAX and test for compound
 
-	movl	(%USP), %eax
-	testl	$1, %eax
+	movq	(%USP), %rax
+	testq	$1, %rax
 	jnz	L1.5
 
 	;;; Object is compound: extract key and return
 
-	movl	_KEY(%eax), %eax
-	movl	%eax, (%USP)
+	movq	_KEY(%rax), %rax
+	movq	%rax, (%USP)
 	ret
 
 L1.5:	;;; Object is a (simple) number:
 	;;; return integer or decimal key as appropriate
 
-	testl	$2, %eax
+	testq	$2, %rax
 	jz	L2.3
 
 	;;; Object is an integer
 
-	movl	$C_LAB(integer_key), (%USP)
+	movq	$C_LAB(integer_key), (%USP)
 	ret
 
 L2.3:	;;; Object is a decimal
 
-	movl	$C_LAB(weakref decimal_key), (%USP)
+	movq	$C_LAB(weakref decimal_key), (%USP)
 	ret
 
-	.align	4
+	.align  16
 
 
 ;;; === STRING HANDLING ===============================================
@@ -757,23 +766,23 @@
 
 DEF_C_LAB (_subss)
 
-	movl	(%USP), %esi
-	movl	4(%USP), %ecx
-	addl	$4, %USP
+	movq	(%USP), %rsi
+	movq	8(%USP), %rcx
+	addq	$8, %USP
 
 	;;; Convert index to a machine integer and load the indexed byte
 	;;; (zero extended) into EAX
 
-	sarl	$2, %ecx
-	movzbl	_V_BYTES-1(%esi, %ecx), %eax
+	sarq	$2, %rcx
+	movzbq	_V_BYTES-1(%rsi, %rcx), %rax
 
 	;;; Return character as a popint
 
-	leal	3(, %eax, 4), %eax
-	movl	%eax, (%USP)
+	leaq	3(, %rax, 4), %rax
+	movq	%rax, (%USP)
 	ret
 
-	.align	4
+	.align  16
 
 ;;; _U_SUBSS:
 ;;;	Fast pop string update (implements updaterof -fast_subscrs-).
@@ -789,20 +798,20 @@
 DEF_C_LAB (-> _subss)
 DEF_C_LAB (_u_subss)
 
-	movl	(%USP), %edi
-	movl	4(%USP), %ecx
-	movl	8(%USP), %eax
-	addl	$12, %USP
+	movq	(%USP), %rdi
+	movq	8(%USP), %rcx
+	movq	16(%USP), %rax
+	addq	$24, %USP
 
 	;;; Convert character and index to machine integers;
 	;;; insert the new byte and return
 
-	sarl	$2, %eax
-	sarl	$2, %ecx
-	movb	%al, _V_BYTES-1(%edi, %ecx)
+	sarq	$2, %rax
+	sarq	$2, %rcx
+	movb	%al, _V_BYTES-1(%rdi, %rcx)
 	ret
 
-	.align	4
+	.align  16
 
 
 ;;; _LOCC:
@@ -822,20 +831,20 @@
 
 DEF_C_LAB (_locc)
 
-	movl	(%USP), %eax
-	movl	4(%USP), %ecx
-	addl	$8, %USP
+	movq	(%USP), %rax
+	movq	8(%USP), %rcx
+	addq	$16, %USP
 
 	;;; Test the byte-count in ECX for zero:
 	;;; if so, nothing to search, so return -1 immediately
 
-	cmpl	$0, %ecx
+	cmpq	$0, %rcx
 	je	L1.6
 
 	;;; Load the string address into EDI, and copy into ESI offset by 1
 
-	movl	(%USP), %edi
-	leal	1(%edi), %esi
+	movq	(%USP), %rdi
+	leaq	1(%rdi), %rsi
 
 	;;; Clear the direction flag to increment EDI during the scan
 
@@ -854,16 +863,16 @@
 	;;; Otherwise, EDI points one beyond the matching byte:
 	;;; compute offset by subtracting ESI (already adjusted by 1)
 
-	subl	%esi, %edi
-	movl	%edi, (%USP)
+	subq	%rsi, %rdi
+	movq	%rdi, (%USP)
 	ret
 
 L1.6:	;;; Search failed -- return -1
 
-	movl	$-1, (%USP)
+	movq	$-1, (%USP)
 	ret
 
-	.align	4
+	.align  16
 
 
 ;;; _SKPC:
@@ -883,20 +892,20 @@
 
 DEF_C_LAB (_skpc)
 
-	movl	(%USP), %eax
-	movl	4(%USP), %ecx
-	addl	$8, %USP
+	movq	(%USP), %rax
+	movq	8(%USP), %rcx
+	addq	$16, %USP
 
 	;;; Test the byte-count in ECX for zero:
 	;;; if so, nothing to search, so return -1 immediately
 
-	cmpl	$0, %ecx
+	cmpq	$0, %rcx
 	je	L1.7
 
 	;;; Load the string address into EDI and copy to ESI offset by 1
 
-	movl	(%USP), %edi
-	leal	1(%edi), %esi
+	movq	(%USP), %rdi
+	leaq	1(%rdi), %rsi
 
 	;;; Clear the direction flag to increment EDI during the scan
 
@@ -915,16 +924,16 @@
 	;;; Otherwise, EDI points one beyond the matching byte:
 	;;; compute offset by subtracting ESI (already adjusted by 1)
 
-	subl	%esi, %edi
-	movl	%edi, (%USP)
+	subq	%rsi, %rdi
+	movq	%rdi, (%USP)
 	ret
 
 L1.7:	;;; Search failed -- return -1
 
-	movl	$-1, (%USP)
+	movq	$-1, (%USP)
 	ret
 
-	.align	4
+	.align  16
 
 
 ;;; === PROCEDURE ENTRY CHECKS ========================================
@@ -935,36 +944,36 @@
 
 DEF_C_LAB (_checkplogall)
 
-	movl	$C_LAB(_special_var_block), %eax
-	movl	_SVB_OFFS(_plog_trail_sp)(%eax), %ecx
-	cmpl	%ecx, _SVB_OFFS(_plog_trail_lim)(%eax)
+	movq	$C_LAB(_special_var_block), %rax
+	movq	_SVB_OFFS(_plog_trail_sp)(%rax), %rcx
+	cmpq	%rcx, _SVB_OFFS(_plog_trail_lim)(%rax)
 	ja	checkall
 	jmp	XC_LAB(weakref[prologvar_key] Sys$-Plog$-Area_overflow)
 
-	.align	4
+	.align  16
 
 ;;; _CHECKALL:
 ;;;	Check normal stacks on procedure entry.
 
 DEF_C_LAB (_checkall)
 
-	movl	$C_LAB(_special_var_block), %eax
+	movq	$C_LAB(_special_var_block), %rax
 
 checkall:
 
 	;;; Check for callstack overflow
 
-	cmpl	%esp, _SVB_OFFS(_call_stack_lim)(%eax)
+	cmpq	%rsp, _SVB_OFFS(_call_stack_lim)(%rax)
 	ja	L1.10
 
 	;;; Check for userstack overflow
 
-	cmpl	%USP, _SVB_OFFS(_userlim)(%eax)
+	cmpq	%USP, _SVB_OFFS(_userlim)(%rax)
 	ja	L2.6
 
 L0.1:	;;; Check interrupt trap bit
 
-	testl	$1, _SVB_OFFS(_trap)(%eax)
+	testq	$1, _SVB_OFFS(_trap)(%rax)
 	jnz	L3.5
 
 	;;; Everything OK
@@ -974,25 +983,25 @@
 L1.10:	;;; Callstack overflow: if not disabled, jump to repair, otherwise
 	;;; go back to test for interrupts
 
-	testl	$2, I_LAB(_disable)
+	testq	$2, I_LAB(_disable)
 	jnz	L0.1
 	jmp	XC_LAB(Sys$-Call_overflow)
 
 L2.6:	;;; Userstack overflow: if not disabled, jump to repair, otherwise
 	;;; go back to test for interrupts
 
-	testl	$2, I_LAB(_disable)
+	testq	$2, I_LAB(_disable)
 	jnz	L0.1
 	jmp	XC_LAB(Sys$-User_overflow)
 
 L3.5:	;;; Interrupt: if not disabled, jump to handler, otherwise return
 
-	testl	$1, I_LAB(_disable)
+	testq	$1, I_LAB(_disable)
 	jz	XC_LAB(Sys$-Async_raise_signal)
 	ret
 
 
-	.align	4
+	.align  16
 
 
 ;;; _CHECKINTERRUPT:
@@ -1000,12 +1009,37 @@
 
 DEF_C_LAB (_checkinterrupt)
 
-	testl	$1, I_LAB(_trap)
+	testq	$1, I_LAB(_trap)
 	jnz	C_LAB(_checkall)
 	ret
 
-	.align	4
+	.align  16
 
+        .data
+mess33:
+        .string "sp = 0x%lx\\n"
+
+        .text
+EXTERN_NAME(pop_print_sp):
+        movq    $mess33, %rdi
+        movq    %rsp, %rsi
+        movl    $0, %eax
+        call    printf
+        ret
+
+/*
+EXTERN_NAME(pop_print):
+        pushq %rbp
+        mov XC_LAB(Sys$-dummy_procedure_callback_helper),%rbp
+        pushq %rbp
+        subq    $8, %USP
+        movq    %rdi, (%USP)
+        call     XC_LAB(sys_syspr)
+        popq %rbp
+        popq %rbp
+        ret
+        .align  16
+*/
 
 /***************** end labels for wrapping structures *****************/
 
